#include <windows.h>
#include <stdio.h>
#include <vector>
#include <string>
#include "PEFile.h"


//! C[`
int main(int argc, char** argv)
{
  for(int i = 1; i < argc; i++)
  {
    printf("%s\n", argv[i]);
    HMODULE module_handle = LoadLibrary(argv[i]);

    std::vector<ExportSymbol>
      export_symbols = PEFile(module_handle).GetExportSymbols();

    if( export_symbols.size() )
    {
      printf("    RVA      O\n");
      for(size_t j = 0; j < export_symbols.size(); j++)
      {
        printf("  %-5d %08X %s\n",
               export_symbols[j].ordinal,
               export_symbols[j].symbol_rva,
               export_symbols[j].name
              );
        if( export_symbols[j].forwarded_to[0] )
          printf("%*s %s\n", 16, "", export_symbols[j].forwarded_to);
      }
      
    }
    printf("\n");
  }
  return 0;
}


